using UnityEngine;
using System.Collections;

public class Block : MonoBehaviour
{
    public Texture2D BlockTextureA;
    public Texture2D BlockTextureB;
    public Texture2D BlockTextureC;
    public Texture2D BlockTextureD;
    public Texture2D BlockTextureE;
    public Texture2D BlockTextureF;
    public Texture2D BlockTextureG;
    public Texture2D BlockTextureH;
    public Texture2D BlockTextureI;
    public Texture2D BlockTextureJ;
    public Texture2D BlockTextureK;
    public Texture2D BlockTextureL;
    public Texture2D BlockTextureM;
    public Texture2D BlockTextureN;
    public Texture2D BlockTextureO;
    public Texture2D BlockTextureP;
    public Texture2D BlockTextureQ;
    public Texture2D BlockTextureR;
    public Texture2D BlockTextureS;
    public Texture2D BlockTextureT;
    public Texture2D BlockTextureU;
    public Texture2D BlockTextureV;
    public Texture2D BlockTextureW;
    public Texture2D BlockTextureX;
    public Texture2D BlockTextureY;
    public Texture2D BlockTextureZ;

    public Texture2D ActivatedBlockTextureA;
    public Texture2D ActivatedBlockTextureB;
    public Texture2D ActivatedBlockTextureC;
    public Texture2D ActivatedBlockTextureD;
    public Texture2D ActivatedBlockTextureE;
    public Texture2D ActivatedBlockTextureF;
    public Texture2D ActivatedBlockTextureG;
    public Texture2D ActivatedBlockTextureH;
    public Texture2D ActivatedBlockTextureI;
    public Texture2D ActivatedBlockTextureJ;
    public Texture2D ActivatedBlockTextureK;
    public Texture2D ActivatedBlockTextureL;
    public Texture2D ActivatedBlockTextureM;
    public Texture2D ActivatedBlockTextureN;
    public Texture2D ActivatedBlockTextureO;
    public Texture2D ActivatedBlockTextureP;
    public Texture2D ActivatedBlockTextureQ;
    public Texture2D ActivatedBlockTextureR;
    public Texture2D ActivatedBlockTextureS;
    public Texture2D ActivatedBlockTextureT;
    public Texture2D ActivatedBlockTextureU;
    public Texture2D ActivatedBlockTextureV;
    public Texture2D ActivatedBlockTextureW;
    public Texture2D ActivatedBlockTextureX;
    public Texture2D ActivatedBlockTextureY;
    public Texture2D ActivatedBlockTextureZ;


    [HideInInspector] public string Letter = "";

    private Texture2D normalTexture;
    private Texture2D activatedTexture;

    void Start()
    {
        if (Letter == "")
        {
            SetLetter(GetRandomLetter());
        }
    }

    public void Activate()
    {
        renderer.material.mainTexture = activatedTexture;
    }

    public void Deactivate()
    {
        renderer.material.mainTexture = normalTexture;
    }

    public void SetLetter(string letter)
    {
        Letter = letter;
        normalTexture = GetNormalTexture(Letter);
        activatedTexture = GetActivatedTexture(Letter);
        renderer.material.mainTexture = normalTexture;
    }

    private string GetRandomLetter()
    {
        float randTestValue = Random.Range(0.0f, 100.0f);
        if (randTestValue <= 8.167f)
        {
            return "A";
        }
        else if (randTestValue <= 9.659f)
        {
            return "B";
        }
        else if (randTestValue <= 12.441f)
        {
            return "C";
        }
        else if (randTestValue <= 16.694f)
        {
            return "D";
        }
        else if (randTestValue <= 29.396f)
        {
            return "E";
        }
        else if (randTestValue <= 31.624f)
        {
            return "F";
        }
        else if (randTestValue <= 33.639f)
        {
            return "G";
        }
        else if (randTestValue <= 39.733f)
        {
            return "H";
        }
        else if (randTestValue <= 46.669f)
        {
            return "I";
        }
        else if (randTestValue <= 46.852f)
        {
            return "J";
        }
        else if (randTestValue <= 47.624f)
        {
            return "K";
        }
        else if (randTestValue <= 51.649f)
        {
            return "L";
        }
        else if (randTestValue <= 54.055f)
        {
            return "M";
        }
        else if (randTestValue <= 60.804f)
        {
            return "N";
        }
        else if (randTestValue <= 68.311f)
        {
            return "O";
        }
        else if (randTestValue <= 70.240f)
        {
            return "P";
        }
        else if (randTestValue <= 70.335f)
        {
            return "Q";
        }
        else if (randTestValue <= 76.322f)
        {
            return "R";
        }
        else if (randTestValue <= 82.649f)
        {
            return "S";
        }
        else if (randTestValue <= 91.705f)
        {
            return "T";
        }
        else if (randTestValue <= 94.463f)
        {
            return "U";
        }
        else if (randTestValue <= 95.441f)
        {
            return "V";
        }
        else if (randTestValue <= 97.801f)
        {
            return "W";
        }
        else if (randTestValue <= 97.951f)
        {
            return "X";
        }
        else if (randTestValue <= 99.925)
        {
            return "Y";
        }
        else
        {
            return "Z";
        }        
    }

    private Texture2D GetNormalTexture(string letter)
    {
        switch (letter)
        {
            case "A":
                return BlockTextureA;
            case "B":
                return BlockTextureB;
            case "C":
                return BlockTextureC;
            case "D":
                return BlockTextureD;
            case "E":
                return BlockTextureE;
            case "F":
                return BlockTextureF;
            case "G":
                return BlockTextureG;
            case "H":
                return BlockTextureH;
            case "I":
                return BlockTextureI;
            case "J":
                return BlockTextureJ;
            case "K":
                return BlockTextureK;
            case "L":
                return BlockTextureL;
            case "M":
                return BlockTextureM;
            case "N":
                return BlockTextureN;
            case "O":
                return BlockTextureO;
            case "P":
                return BlockTextureP;
            case "Q":
                return BlockTextureQ;
            case "R":
                return BlockTextureR;
            case "S":
                return BlockTextureS;
            case "T":
                return BlockTextureT;
            case "U":
                return BlockTextureU;
            case "V":
                return BlockTextureV;
            case "W":
                return BlockTextureW;
            case "X":
                return BlockTextureX;
            case "Y":
                return BlockTextureY;
            case "Z":
                return BlockTextureZ;
        }

        return null;
    }

    private Texture2D GetActivatedTexture(string letter)
    {
        switch (letter)
        {
            case "A":
                return ActivatedBlockTextureA;
            case "B":
                return ActivatedBlockTextureB;
            case "C":
                return ActivatedBlockTextureC;
            case "D":
                return ActivatedBlockTextureD;
            case "E":
                return ActivatedBlockTextureE;
            case "F":
                return ActivatedBlockTextureF;
            case "G":
                return ActivatedBlockTextureG;
            case "H":
                return ActivatedBlockTextureH;
            case "I":
                return ActivatedBlockTextureI;
            case "J":
                return ActivatedBlockTextureJ;
            case "K":
                return ActivatedBlockTextureK;
            case "L":
                return ActivatedBlockTextureL;
            case "M":
                return ActivatedBlockTextureM;
            case "N":
                return ActivatedBlockTextureN;
            case "O":
                return ActivatedBlockTextureO;
            case "P":
                return ActivatedBlockTextureP;
            case "Q":
                return ActivatedBlockTextureQ;
            case "R":
                return ActivatedBlockTextureR;
            case "S":
                return ActivatedBlockTextureS;
            case "T":
                return ActivatedBlockTextureT;
            case "U":
                return ActivatedBlockTextureU;
            case "V":
                return ActivatedBlockTextureV;
            case "W":
                return ActivatedBlockTextureW;
            case "X":
                return ActivatedBlockTextureX;
            case "Y":
                return ActivatedBlockTextureY;
            case "Z":
                return ActivatedBlockTextureZ;
        }

        return null;
    }
	
	void Update()
    {
	}
}
